]> arthur.barton.de Git - ngircd-alex.git/blobdiff - autogen.sh
Don't abort startup when setgid/setuid() fails with EINVAL
[ngircd-alex.git] / autogen.sh
index cca200b2a452d02478224566f135fdf0b8ca4eed..0cf9a0e391b5ac8425c2ba54e03a690b5ea6ca80 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 #
 # ngIRCd -- The Next Generation IRC Daemon
-# Copyright (c)2001-2012 Alexander Barton (alex@barton.de) and Contributors
+# Copyright (c)2001-2024 Alexander Barton (alex@barton.de) and Contributors
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # GNU autoconf. It tries to be smart in finding the correct/usable/available
 # installed versions of these tools on your system.
 #
+# In addition, it enables or disables the "de-ANSI-fication" support of GNU
+# automake, which is supported up to autoconf 1.11.x an has been removed
+# in automake 1.12 -- make sure to use a version of automake supporting it
+# when generating distribution archives!
+#
 # The following strategy is used for each of aclocal, autoheader, automake,
 # and autoconf: first, "tool" (the regular name of the tool, e. g. "autoconf"
 # or "automake") is checked. If this fails, "tool<major><minor>" (for example
 #   and runs it with these arguments: "./configure --prefix=$HOME".
 #
 
+Check_Tool()
+{
+       searchlist="$1"
+       major="$2"
+       minor="$3"
+
+       for name in $searchlist; do
+               $EXIST "${name}${major}${minor}" >/dev/null 2>&1
+               if [ $? -eq 0 ]; then
+                       echo "${name}${major}${minor}"
+                       return 0
+               fi
+               $EXIST "${name}-${major}.${minor}" >/dev/null 2>&1
+               if [ $? -eq 0 ]; then
+                       echo "${name}-${major}.${minor}"
+                       return 0
+               fi
+       done
+       return 1
+}
+
 Search()
 {
-       [ $# -eq 2 ] || exit 1
+       [ $# -lt 2 ] && return 1
+       [ $# -gt 3 ] && return 1
 
        searchlist="$1"
        major="$2"
+       minor_pref="$3"
        minor=99
 
        [ -n "$PREFIX" ] && searchlist="${PREFIX}/$1 ${PREFIX}/bin/$1 $searchlist"
 
+       if [ -n "$minor_pref" ]; then
+               Check_Tool "$searchlist" "$major" "$minor_pref" && return 0
+       fi
+
        for name in $searchlist; do
                $EXIST "${name}" >/dev/null 2>&1
                if [ $? -eq 0 ]; then
-                       echo "${name}"
-                       return 0
+                       "${name}" --version 2>&1 \
+                        | grep -v "environment variable" >/dev/null 2>&1
+                       if [ $? -eq 0 ]; then
+                               echo "${name}"
+                               return 0
+                       fi
                fi
        done
 
        while [ $minor -ge 0 ]; do
-               for name in $searchlist; do
-                       $EXIST "${name}${major}${minor}" >/dev/null 2>&1
-                       if [ $? -eq 0 ]; then
-                               echo "${name}${major}${minor}"
-                               return 0
-                       fi
-                       $EXIST "${name}-${major}.${minor}" >/dev/null 2>&1
-                       if [ $? -eq 0 ]; then
-                               echo "${name}-${major}.${minor}"
-                               return 0
-                       fi
-               done
-               minor=`expr $minor - 1`
+               Check_Tool "$searchlist" "$major" "$minor" && return 0
+               minor=$(expr $minor - 1)
        done
        return 1
 }
@@ -94,14 +119,15 @@ Search()
 Notfound()
 {
        echo "Error: $* not found!"
-       echo "Please install recent versions of GNU autoconf and GNU automake."
+       echo 'Please install supported versions of GNU autoconf, GNU automake'
+       echo 'and pkg-config: see the INSTALL file for details.'
        exit 1
 }
 
 Run()
 {
-       [ "$VERBOSE" = "1" ] && echo " - running \"$@\" ..."
-       $@
+       [ "$VERBOSE" = "1" ] && echo " - running \"$*\" ..."
+       "$@"
 }
 
 # Reset locale settings to suppress warning messages of Perl
@@ -129,43 +155,91 @@ fi
 
 # Try to detect the needed tools when no environment variable already
 # specifies one:
-echo "Searching tools ..."
-[ -z "$ACLOCAL" ] && ACLOCAL=`Search aclocal 1`
+echo "Searching for required tools ..."
+[ -z "$ACLOCAL" ] && ACLOCAL=$(Search aclocal 1 11)
 [ "$VERBOSE" = "1" ] && echo " - ACLOCAL=$ACLOCAL"
-[ -z "$AUTOHEADER" ] && AUTOHEADER=`Search autoheader 2`
+[ -z "$AUTOHEADER" ] && AUTOHEADER=$(Search autoheader 2)
 [ "$VERBOSE" = "1" ] && echo " - AUTOHEADER=$AUTOHEADER"
-[ -z "$AUTOMAKE" ] && AUTOMAKE=`Search automake 1`
+[ -z "$AUTOMAKE" ] && AUTOMAKE=$(Search automake 1 11)
 [ "$VERBOSE" = "1" ] && echo " - AUTOMAKE=$AUTOMAKE"
-[ -z "$AUTOCONF" ] && AUTOCONF=`Search autoconf 2`
+[ -z "$AUTOCONF" ] && AUTOCONF=$(Search autoconf 2)
 [ "$VERBOSE" = "1" ] && echo " - AUTOCONF=$AUTOCONF"
 
-# Call ./configure when parameters have been passed to this script and
-# GO isn't already defined.
-[ -z "$GO" -a $# -gt 0 ] && GO=1
+AUTOCONF_VERSION=$(echo "$AUTOCONF" | cut -d'-' -f2-)
+[ -n "$AUTOCONF_VERSION" ] && [ "$AUTOCONF_VERSION" != "autoconf" ] \
+       && export AUTOCONF_VERSION || unset AUTOCONF_VERSION
+[ "$VERBOSE" = "1" ] && echo " - AUTOCONF_VERSION=$AUTOCONF_VERSION"
+AUTOMAKE_VERSION=$(echo $AUTOMAKE | cut -d'-' -f2-)
+[ -n "$AUTOMAKE_VERSION" ] && [ "$AUTOMAKE_VERSION" != "automake" ] \
+       && export AUTOMAKE_VERSION || unset AUTOMAKE_VERSION
+[ "$VERBOSE" = "1" ] && echo " - AUTOMAKE_VERSION=$AUTOMAKE_VERSION"
+
+[ $# -gt 0 ] && CONFIGURE_ARGS=" $*" || CONFIGURE_ARGS=""
+[ -z "$GO" ] && [ -n "$CONFIGURE_ARGS" ] && GO=1
 
 # Verify that all tools have been found
+command -v pkg-config >/dev/null || Notfound pkg-config
 [ -z "$ACLOCAL" ] && Notfound aclocal
 [ -z "$AUTOHEADER" ] && Notfound autoheader
 [ -z "$AUTOMAKE" ] && Notfound automake
 [ -z "$AUTOCONF" ] && Notfound autoconf
 
+AM_VERSION=$($AUTOMAKE --version | head -n 1 | sed -e 's/.* //g')
+ifs=$IFS; IFS="."; set $AM_VERSION; IFS=$ifs
+AM_MAJOR="$1"; AM_MINOR="$2"
+echo "Detected automake $AM_VERSION ..."
+
+AM_MAKEFILES="src/ipaddr/Makefile.ng src/ngircd/Makefile.ng src/testsuite/Makefile.ng src/tool/Makefile.ng"
+
+# De-ANSI-fication?
+if [ "$AM_MAJOR" -eq "1" ] && [ "$AM_MINOR" -lt "12" ]; then
+       # automake < 1.12 => automatic de-ANSI-fication support available
+       echo " - Enabling de-ANSI-fication support."
+       sed -e "s|^__ng_PROTOTYPES__|AM_C_PROTOTYPES|g" configure.ng >configure.ac
+       DEANSI_START=""
+       DEANSI_END=""
+else
+       # automake >= 1.12 => no de-ANSI-fication support available
+       echo " - Disabling de-ANSI-fication support."
+       sed -e "s|^__ng_PROTOTYPES__|AC_C_PROTOTYPES|g" configure.ng >configure.ac
+       DEANSI_START="#"
+       DEANSI_END=" (disabled by ./autogen.sh script)"
+fi
+# Serial test harness?
+if [ "$AM_MAJOR" -eq "1" ] && [ "$AM_MINOR" -ge "13" ]; then
+       # automake >= 1.13 => enforce "serial test harness"
+       echo " - Enforcing serial test harness."
+       SERIAL_TESTS="serial-tests"
+else
+       # automake < 1.13 => no new test harness, nothing to do
+       # shellcheck disable=SC2034
+       SERIAL_TEST=""
+fi
+
+sed -e "s|^__ng_Makefile_am_template__|AUTOMAKE_OPTIONS = ${SERIAL_TESTS} ${DEANSI_START}ansi2knr${DEANSI_END}|g" \
+       src/portab/Makefile.ng >src/portab/Makefile.am
+for makefile_ng in $AM_MAKEFILES; do
+       makefile_am=$(echo "$makefile_ng" | sed -e "s|\.ng\$|\.am|g")
+       sed -e "s|^__ng_Makefile_am_template__|AUTOMAKE_OPTIONS = ${SERIAL_TESTS} ${DEANSI_START}../portab/ansi2knr${DEANSI_END}|g" \
+               $makefile_ng >$makefile_am
+done
+
 export ACLOCAL AUTOHEADER AUTOMAKE AUTOCONF
 
 # Generate files
-echo "Generating files ..."
+echo "Generating files using \"$AUTOCONF\" and \"$AUTOMAKE\" ..."
 Run $ACLOCAL && \
        Run $AUTOCONF && \
        Run $AUTOHEADER && \
        Run $AUTOMAKE --add-missing --no-force
 
-if [ $? -eq 0 -a -x ./configure ]; then
+if [ $? -eq 0 ] && [ -x ./configure ]; then
        # Success: if we got some parameters we call ./configure and pass
        # all of them to it.
-       NAME=`grep PACKAGE_STRING= configure | cut -d"'" -f2`
+       NAME=$(grep PACKAGE_STRING= configure | cut -d"'" -f2)
        if [ "$GO" = "1" ]; then
                [ -n "$PREFIX" ] && p=" --prefix=$PREFIX" || p=""
-               [ -n "$*" ] && a=" $*" || a=""
-               c="./configure${p}${a}"
+               c="./configure${p}${CONFIGURE_ARGS}"
                echo "Okay, autogen.sh for $NAME done."
                echo "Calling \"$c\" ..."
                $c